#ifndef PARTICLE_H
#define PARTICLE_H

#include "ofMain.h"
#include "ofxVectorMath.h"


typedef struct{
	int			count;
	ofxVec3f	sum;
	float		distance;
	float		strength;
} flockingForce;
 

class particle
{
    public:
        ofxVec3f pos;
        ofxVec3f vel;
        ofxVec3f frc;   // frc is also know as acceleration (newton says "f=ma")
		
		unsigned int bitFlagW;
		unsigned int bitFlagH;
	
        particle();
		virtual ~particle(){};

        void resetForce();
		void setup();
		void addForce(float x, float y,float z);
		void addRepulsionForce(float x, float y, float z, float radius, float scale);
		void addAttractionForce(float x, float y, float z, float radius, float scale);
		void addRepulsionForce(particle &p, float radius, float scale);
		void addAttractionForce(particle &p, float radius, float scale);
		
		void addDampingForce();
        
		void setInitialCondition(float px, float py, float vx, float vy);
        void update();
        void draw();
	
		void addForFlocking(particle &p);
		void addFlockingForce();
	
		flockingForce cohesion;
		flockingForce seperation;
		flockingForce alignment;

		void bounceOffWalls();
	
		ofImage * bg;
		vector <ofxVec3f> trail;
		float damping;
    protected:
    private:
};

#endif // PARTICLE_H
